// Package invokermanagementapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package invokermanagementapi

import (
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/publishserviceapi"
)

// Information about the API Invoker that requested to onboard
type APIInvokerEnrolmentDetails struct {
	// API invoker ID assigned by the CAPIF core function to the API invoker while on-boarding the API invoker. Shall not be present in the HTTP POST request from the API invoker to the CAPIF core function, to on-board itself. Shall be present in all other HTTP requests and responses.
	ApiInvokerId *string `json:"apiInvokerId,omitempty"`

	// Generic information related to the API invoker such as details of the device or the application.
	ApiInvokerInformation *string `json:"apiInvokerInformation,omitempty"`

	// The list of service APIs that the API Invoker is allowed to invoke
	ApiList *APIList `json:"apiList,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	NotificationDestination externalRef0.Uri `json:"notificationDestination"`

	// Represents on-boarding information of the API invoker.
	OnboardingInformation OnboardingInformation `json:"onboardingInformation"`

	// Set to true by Subscriber to request the CAPIF core function to send a test notification as defined in in subclause 7.6. Set to false or omitted otherwise.
	RequestTestNotification *bool `json:"requestTestNotification,omitempty"`

	// A string used to indicate the features supported by an API that is used as defined in clause  6.6 in 3GPP TS 29.500. The string shall contain a bitmask indicating supported features in  hexadecimal representation Each character in the string shall take a value of "0" to "9",  "a" to "f" or "A" to "F" and shall represent the support of 4 features as described in  table 5.2.2-3. The most significant character representing the highest-numbered features shall  appear first in the string, and the character representing features 1 to 4 shall appear last  in the string. The list of features and their numbering (starting with 1) are defined  separately for each API. If the string contains a lower number of characters than there are  defined features for an API, all features that would be represented by characters that are not  present in the string are not supported.
	SupportedFeatures *externalRef1.SupportedFeatures `json:"supportedFeatures,omitempty"`

	// Represents the configuration information for the delivery of notifications over Websockets.
	WebsockNotifConfig *externalRef0.WebsockNotifConfig `json:"websockNotifConfig,omitempty"`
}

// Represents an API Invoker’s enrolment details to be updated.
type APIInvokerEnrolmentDetailsPatch struct {
	// Generic information related to the API invoker such as details of the device or the application.
	ApiInvokerInformation *string `json:"apiInvokerInformation,omitempty"`

	// The list of service APIs that the API Invoker is allowed to invoke
	ApiList *APIList `json:"apiList,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	NotificationDestination *externalRef0.Uri `json:"notificationDestination,omitempty"`

	// Represents on-boarding information of the API invoker.
	OnboardingInformation *OnboardingInformation `json:"onboardingInformation,omitempty"`
}

// The list of service APIs that the API Invoker is allowed to invoke
type APIList []externalRef2.ServiceAPIDescription

// Represents on-boarding information of the API invoker.
type OnboardingInformation struct {
	// The API Invoker’s generic client certificate, provided by the CAPIF core function.
	ApiInvokerCertificate *string `json:"apiInvokerCertificate,omitempty"`

	// The API Invoker’s public key
	ApiInvokerPublicKey string `json:"apiInvokerPublicKey"`

	// The API Invoker’s onboarding secret, provided by the CAPIF core function.
	OnboardingSecret *string `json:"onboardingSecret,omitempty"`
}

// Represents a notification of on-boarding or update result.
type OnboardingNotification struct {
	// Information about the API Invoker that requested to onboard
	ApiInvokerEnrolmentDetails *APIInvokerEnrolmentDetails `json:"apiInvokerEnrolmentDetails,omitempty"`

	// The list of service APIs that the API Invoker is allowed to invoke
	ApiList *APIList `json:"apiList,omitempty"`

	// string providing an URI formatted according to IETF RFC 3986.
	ResourceLocation *externalRef0.Uri `json:"resourceLocation,omitempty"`

	// Set to "true" indicate successful on-boarding. Otherwise set to "false"
	Result bool `json:"result"`
}

// PostOnboardedInvokersJSONBody defines parameters for PostOnboardedInvokers.
type PostOnboardedInvokersJSONBody APIInvokerEnrolmentDetails

// PutOnboardedInvokersOnboardingIdJSONBody defines parameters for PutOnboardedInvokersOnboardingId.
type PutOnboardedInvokersOnboardingIdJSONBody APIInvokerEnrolmentDetails

// PostOnboardedInvokersJSONRequestBody defines body for PostOnboardedInvokers for application/json ContentType.
type PostOnboardedInvokersJSONRequestBody PostOnboardedInvokersJSONBody

// PutOnboardedInvokersOnboardingIdJSONRequestBody defines body for PutOnboardedInvokersOnboardingId for application/json ContentType.
type PutOnboardedInvokersOnboardingIdJSONRequestBody PutOnboardedInvokersOnboardingIdJSONBody
